<template>
  <PageWrapper dense>
    <Row>
      <!-- 左边部门选择 -->
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 4 }" class="h-[calc(100vh-80px)]">
        <DeptTree
          v-model:selectDeptId="selectDeptId"
          v-model:searchValue="searchValue"
          @select="reload"
        />
      </Col>
      <Col v-bind="{ xs: 24, sm: 24, md: 24, lg: 20 }">
        <BasicTable @register="registerTable">
          <template #toolbar>
            <a-button
              @click="
                downloadExcel(infoExport, '物业单位基础信息;数据', getForm().getFieldsValue())
              "
              v-auth="'tenement:info:export'"
              >导出</a-button
            >
            <a-button
              type="primary"
              danger
              @click="multipleRemove(infoRemove)"
              :disabled="!selected"
              v-auth="'elevator:tenementInfo:remove'"
              >删除</a-button
            >
            <a-button type="primary" @click="handleAdd" v-auth="'elevator:tenementInfo:add'"
              >新增</a-button
            >
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'action'">
              <TableAction
                stopButtonPropagation
                :actions="[
                  {
                    label: '查看',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:tenementInfo:query',
                    onClick: handCheck.bind(null, record),
                  },
                  {
                    label: '修改',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:tenementInfo:edit	',
                    onClick: handleEdit.bind(null, record),
                  },
                  {
                    label: '删除',

                    type: 'primary',
                    danger: true,
                    ghost: true,
                    auth: 'elevator:tenementInfo:remove',
                    popConfirm: {
                      placement: 'left',
                      title: '是否删除物业单位基础信息;[' + record.id + ']?',
                      confirm: handleDelete.bind(null, record),
                    },
                  },
                  {
                    label: '用户管理',

                    type: 'primary',
                    ghost: true,
                    auth: 'elevator:tenementInfo:userManage',
                    onClick: handleOpenUserModal.bind(null, record),
                  },
                ]"
              />
            </template>
          </template>
        </BasicTable>
      </Col>
    </Row>

    <InfoModal @register="registerModal" @reload="reload" />
    <UserManageModal @register="registerUserModal"></UserManageModal>
  </PageWrapper>
</template>

<script setup lang="ts">
import { PageWrapper } from '@/components/Page';
import { BasicTable, useTable, TableAction } from '@/components/Table';
import { infoList, infoExport, infoRemove } from '@/api/basicInfo/tenement';
import { downloadExcel } from '@/utils/file/download';
import { useModal } from '@/components/Modal';
import InfoModal from './InfoModal.vue';
import { formSchemas, columns } from './info.data';
import UserManageModal from '@/components/CommonUserManageModal/UserManageModal.vue';
import DeptTree from '@/components/commonDeptTree/DeptTree.vue';
import { ref, toValue } from 'vue';
import { Row, Col } from 'ant-design-vue';
defineOptions({ name: 'Info' });
const selectDeptId = ref<string[]>([]);
const searchValue = ref<string>('');
const [registerTable, { reload, multipleRemove, selected, getForm }] = useTable({
  rowSelection: {
    type: 'checkbox',
  },
  title: '物业单位基础信息;列表',
  api: infoList,
  showIndexColumn: true,
  rowKey: 'id',
  useSearchForm: true,
  formConfig: {
    schemas: formSchemas,
    baseColProps: {
      xs: 24,
      sm: 24,
      md: 24,
      lg: 6,
    },
    resetFunc: async () => {
      selectDeptId.value = [];
      searchValue.value = '';
      await reload();
    },
  },
  // 需要添加上部门参数
  beforeFetch(params: Recordable) {
    if (toValue(selectDeptId).length === 1) {
      params.deptId = toValue(selectDeptId)[0];
    }
    return params;
  },
  columns: columns,
  actionColumn: {
    width: 250,
    title: '操作',
    key: 'action',
    fixed: 'right',
  },
});

const [registerModal, { openModal }] = useModal();
const [registerUserModal, { openModal: openUserModal }] = useModal();

function handleEdit(record: Recordable) {
  openModal(true, { record, update: 1 });
}

function handleAdd() {
  openModal(true, { update: 2 });
}
function handCheck(record: Recordable) {
  openModal(true, { record, update: 3 });
}
async function handleDelete(record: Recordable) {
  await infoRemove([record.id]);
  await reload();
}
function handleOpenUserModal(record: Recordable) {
  openUserModal(true, { record, update: 3 });
}
</script>

<style scoped></style>
